//! AbleOS Kernel Entrypoint

use log::{info, trace};

use crate::arch::sloop;
use crate::{interp, task};

use crate::alloc::string::ToString;

pub fn kmain(cmdline: &str, bootstrap: Option<&'static [u8]>) -> ! {
    log::debug!("Entered kmain");

    let mut cmdline = cmdline.to_string();
    cmdline.pop();
    cmdline.remove(0);

    let kcmd = clparse::Arguments::parse(cmdline.to_string()).unwrap();
    log::info!("Cmdline: {kcmd:?}");

    if kcmd.arguments.get("baka") == Some(&"9".to_string()) {
        let _ = crate::arch::log(format_args!(include_str!("../data/⑨. バカ")));
    }

    let bootstrap = bootstrap/*.expect("no bootstrap found")*/;
    match bootstrap {
        Some(bootstrap_mod) => {}
        None => {
            info!("No bootstrap module loaded.")
        }
    }

    // use xml::XMLElement;
    // let kcmd = XMLElement::new("cmdline");

    let abc = interp::wasm();

    trace!("{:?}", abc);
    crate::arch::sloop()
}
